Index: trunk/source/processes/electromagnetic/utils/include/G4VEmProcess.hh
===================================================================
--- trunk/source/processes/electromagnetic/utils/include/G4VEmProcess.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/utils/include/G4VEmProcess.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4VEmProcess.hh,v 1.50 2009/02/19 09:57:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4VEmProcess.hh,v 1.47 2008/07/31 13:01:26 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -108,8 +108,19 @@
 
   //------------------------------------------------------------------------
-  // Implementation of virtual methods common to all Discrete processes 
+  // Methods with standard implementation; may be overwritten if needed 
+  //------------------------------------------------------------------------
+
+  inline G4double RecalculateLambda(G4double kinEnergy,
+				    const G4MaterialCutsCouple* couple);
+
+  //------------------------------------------------------------------------
+  // Generic methods common to all Discrete processes 
   //------------------------------------------------------------------------
 
 public:
+
+  void PrintInfoDefinition();
+
+  G4VParticleChange* PostStepDoIt(const G4Track&, const G4Step&);
 
   // Initialise for build of tables
@@ -118,16 +129,4 @@
   // Build physics table during initialisation
   void BuildPhysicsTable(const G4ParticleDefinition&);
-
-  void PrintInfoDefinition();
-
-  // implementation of virtual method, specific for G4VEmProcess
-  G4double PostStepGetPhysicalInteractionLength(
-                             const G4Track& track,
-                             G4double   previousStepSize,
-                             G4ForceCondition* condition
-                            );
-
-  // implementation of virtual method, specific for G4VEmProcess
-  G4VParticleChange* PostStepDoIt(const G4Track&, const G4Step&);
 
   // Store PhysicsTable in a file.
@@ -146,7 +145,4 @@
 			      G4bool ascii);
 
-  // deexcitation activated per G4Region
-  void ActivateDeexcitation(G4bool, const G4Region* r = 0);
-
   //------------------------------------------------------------------------
   // Specific methods for Discrete EM post step simulation 
@@ -156,4 +152,11 @@
   G4double CrossSectionPerVolume(G4double kineticEnergy,
 				 const G4MaterialCutsCouple* couple);
+
+  // implementation of virtual method
+  virtual G4double PostStepGetPhysicalInteractionLength(
+                             const G4Track& track,
+                             G4double   previousStepSize,
+                             G4ForceCondition* condition
+                            );
 
   // It returns the cross section of the process per atom
@@ -164,4 +167,7 @@
   inline G4double MeanFreePath(const G4Track& track);
 
+  inline G4VEmModel* SelectModelForMaterial(G4double kinEnergy, 
+					    size_t& idxRegion) const;
+
   // It returns cross section per volume
   inline G4double GetLambda(G4double& kinEnergy, 
@@ -197,25 +203,15 @@
 
   //------------------------------------------------------------------------
-  // Specific methods to set, access, modify models and basic parameters
-  //------------------------------------------------------------------------
-
-protected:
-  // Select model in run time
-  inline void SelectModel(G4double& kinEnergy);
-
-public:
-  // Select model by energy and region index
-  inline G4VEmModel* SelectModelForMaterial(G4double kinEnergy, 
-					    size_t& idxRegion) const;
+  // Specific methods to set, access, modify models
+  //------------------------------------------------------------------------
+
+  // Add EM model coupled for the region
+  inline void AddEmModel(G4int, G4VEmModel*, const G4Region* region = 0);
    
-  // Add model for region, smaller value of order defines which
-  // model will be selected for a given energy interval  
-  inline void AddEmModel(G4int, G4VEmModel*, const G4Region* region = 0);
-
   // Assign a model to a process
-  inline void SetModel(G4VEmModel*, G4int index = 1);
+  inline void SetModel(G4VEmModel*);
   
   // return the assigned model
-  inline G4VEmModel* Model(G4int index = 1);
+  inline G4VEmModel* Model();
     
   // Define new energy range for the model identified by the name
@@ -225,4 +221,10 @@
   inline G4VEmModel* GetModelByIndex(G4int idx = 0, G4bool ver = false);
 
+  //------------------------------------------------------------------------
+  // Get/set parameters used for simulation of energy loss
+  //------------------------------------------------------------------------
+
+  inline void ActivateDeexcitation(G4bool, const G4Region* r = 0);
+
   inline void SetLambdaFactor(G4double val);
 
@@ -231,8 +233,4 @@
 
   inline void SetApplyCuts(G4bool val);
-
-  //------------------------------------------------------------------------
-  // Other generic methods
-  //------------------------------------------------------------------------
   
 protected:
@@ -244,7 +242,4 @@
   G4PhysicsVector* LambdaPhysicsVector(const G4MaterialCutsCouple*);
 
-  inline G4double RecalculateLambda(G4double kinEnergy,
-				    const G4MaterialCutsCouple* couple);
-
   inline G4ParticleChangeForGamma* GetParticleChange();
 
@@ -253,4 +248,6 @@
   inline void SetSecondaryParticle(const G4ParticleDefinition* p);
 
+  inline G4VEmModel* SelectModel(G4double& kinEnergy);
+
   inline size_t CurrentMaterialCutsCoupleIndex() const;
 
@@ -283,5 +280,6 @@
   inline G4double ComputeCurrentLambda(G4double kinEnergy);
 
-  // copy constructor and hide assignment operator
+  // hide  assignment operator
+
   G4VEmProcess(G4VEmProcess &);
   G4VEmProcess & operator=(const G4VEmProcess &right);
@@ -299,6 +297,4 @@
   // ======== Parameters of the class fixed at initialisation =======
 
-  std::vector<G4VEmModel*>     emModels;
-
   // tables and vectors
   G4PhysicsTable*              theLambdaTable;
@@ -321,9 +317,8 @@
   G4bool                       applyCuts;
   G4bool                       startFromNull;
-  G4bool                       useDeexcitation;
-
-  G4int                        nDERegions;
-  std::vector<const G4Region*> deRegions;
-  G4bool*                      idxDERegions;
+
+  G4int                        nRegions;
+  std::vector<G4Region*>       regions;
+  std::vector<G4bool>          flagsDeexcitation;
 
   // ======== Cashed values - may be state dependent ================
@@ -337,5 +332,5 @@
   std::vector<G4DynamicParticle*> secParticles;
 
-  G4VEmModel*                  currentModel;  
+  G4VEmModel*                  selectedModel;  
 
   const G4ParticleDefinition*  particle;
@@ -353,280 +348,4 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::ComputeCrossSectionPerAtom(
-		 G4double kineticEnergy, G4double Z, G4double A, G4double cut)
-{
-  SelectModel(kineticEnergy);
-  G4double x = 0.0;
-  if(currentModel) {
-   x = currentModel->ComputeCrossSectionPerAtom(particle,kineticEnergy,
-						 Z,A,cut);
-  }
-  return x;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::MeanFreePath(const G4Track& track)
-{
-  DefineMaterial(track.GetMaterialCutsCouple());
-  preStepLambda = GetCurrentLambda(track.GetKineticEnergy());
-  G4double x = DBL_MAX;
-  if(DBL_MIN < preStepLambda) x = 1.0/preStepLambda;
-  return x;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::GetLambda(G4double& kineticEnergy,
-					const G4MaterialCutsCouple* couple)
-{
-  DefineMaterial(couple);
-  return GetCurrentLambda(kineticEnergy);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetLambdaBinning(G4int nbins)
-{
-  nLambdaBins = nbins;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4int G4VEmProcess::LambdaBinning() const
-{
-  return nLambdaBins;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetMinKinEnergy(G4double e)
-{
-  minKinEnergy = e;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::MinKinEnergy() const
-{
-  return minKinEnergy;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetMaxKinEnergy(G4double e)
-{
-  maxKinEnergy = e;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::MaxKinEnergy() const
-{
-  return maxKinEnergy;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetPolarAngleLimit(G4double val)
-{
-  if(val < 0.0)     polarAngleLimit = 0.0;
-  else if(val > pi) polarAngleLimit = pi;
-  else              polarAngleLimit = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::PolarAngleLimit() const
-{
-  return polarAngleLimit;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline const G4PhysicsTable* G4VEmProcess::LambdaTable() const
-{
-  return theLambdaTable;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline const G4ParticleDefinition* G4VEmProcess::Particle() const
-{
-  return particle;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline const G4ParticleDefinition* G4VEmProcess::SecondaryParticle() const
-{
-  return secondaryParticle;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SelectModel(G4double& kinEnergy)
-{
-  currentModel = modelManager->SelectModel(kinEnergy, currentMaterialIndex);
-  currentModel->SetCurrentCouple(currentCouple);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4VEmModel* G4VEmProcess::SelectModelForMaterial(
-                                   G4double kinEnergy, size_t& idxRegion) const
-{
-  return modelManager->SelectModel(kinEnergy, idxRegion);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::AddEmModel(G4int order, G4VEmModel* p, 
-				     const G4Region* region)
-{
-  G4VEmFluctuationModel* fm = 0;
-  modelManager->AddEmModel(order, p, fm, region);
-  if(p) p->SetParticleChange(pParticleChange);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetModel(G4VEmModel* p, G4int index)
-{
-  G4int n = emModels.size();
-  if(index >= n) for(G4int i=n; i<index+1; i++) {emModels.push_back(0);}
-  emModels[index] = p;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4VEmModel* G4VEmProcess::Model(G4int index)
-{
-  G4VEmModel* p = 0;
-  if(index >= 0 && index <  G4int(emModels.size())) p = emModels[index];
-  return p;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::UpdateEmModel(const G4String& nam, 
-					G4double emin, G4double emax)
-{
-  modelManager->UpdateEmModel(nam, emin, emax);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4VEmModel* G4VEmProcess::GetModelByIndex(G4int idx, G4bool ver)
-{
-  return modelManager->GetModel(idx, ver);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetLambdaFactor(G4double val)
-{
-  if(val > 0.0 && val <= 1.0) lambdaFactor = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetIntegral(G4bool val)
-{
-  if(particle && particle != theGamma) integral = val;
-  if(integral) buildLambdaTable = true;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4bool G4VEmProcess::IsIntegral() const
-{
-  return integral;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetApplyCuts(G4bool val)
-{
-  applyCuts = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::RecalculateLambda(G4double e, 
-						const G4MaterialCutsCouple* couple)
-{
-  DefineMaterial(couple);
-  return ComputeCurrentLambda(e);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4ParticleChangeForGamma* G4VEmProcess::GetParticleChange()
-{
-  return &fParticleChange;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetParticle(const G4ParticleDefinition* p)
-{
-  particle = p;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetSecondaryParticle(const G4ParticleDefinition* p)
-{
-  secondaryParticle = p;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline size_t G4VEmProcess::CurrentMaterialCutsCoupleIndex() const 
-{
-  return currentMaterialIndex;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::GetGammaEnergyCut()
-{
-  return (*theCutsGamma)[currentMaterialIndex];
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::GetElectronEnergyCut()
-{
-  return (*theCutsElectron)[currentMaterialIndex];
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetBuildTableFlag(G4bool val)
-{
-  buildLambdaTable = val;
-  if(!val) integral = false;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::SetStartFromNullFlag(G4bool val)
-{
-  startFromNull = val;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void G4VEmProcess::InitialiseStep(const G4Track& track)
-{
-  preStepKinEnergy = track.GetKineticEnergy();
-  DefineMaterial(track.GetMaterialCutsCouple());
-  if (theNumberOfInteractionLengthLeft < 0.0) mfpKinEnergy = DBL_MAX;
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
@@ -639,4 +358,61 @@
     mfpKinEnergy = DBL_MAX;
   }
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::InitialiseStep(const G4Track& track)
+{
+  preStepKinEnergy = track.GetKineticEnergy();
+  DefineMaterial(track.GetMaterialCutsCouple());
+  if (theNumberOfInteractionLengthLeft < 0.0) mfpKinEnergy = DBL_MAX;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::GetLambda(G4double& kineticEnergy,
+					const G4MaterialCutsCouple* couple)
+{
+  DefineMaterial(couple);
+  return GetCurrentLambda(kineticEnergy);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::GetCurrentLambda(G4double e)
+{
+  G4double x = 0.0;
+  if(theLambdaTable) x = GetLambdaFromTable(e);
+  else               x = ComputeCurrentLambda(e);
+  return x;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::RecalculateLambda(G4double e, 
+						const G4MaterialCutsCouple* couple)
+{
+  DefineMaterial(couple);
+  return ComputeCurrentLambda(e);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::ComputeCurrentLambda(G4double e)
+{
+  G4VEmModel* currentModel = SelectModel(e);
+  G4double x = 0.0;
+  if(currentModel) 
+    x = currentModel->CrossSectionPerVolume(currentMaterial,particle,
+					    e,(*theCuts)[currentMaterialIndex]);
+  return x;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::GetLambdaFromTable(G4double e)
+{
+  G4bool b;
+  return (((*theLambdaTable)[currentMaterialIndex])->GetValue(e, b));
 }
 
@@ -666,17 +442,10 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline G4double G4VEmProcess::GetLambdaFromTable(G4double e)
-{
-  G4bool b;
-  return (((*theLambdaTable)[currentMaterialIndex])->GetValue(e, b));
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4VEmProcess::GetCurrentLambda(G4double e)
-{
-  G4double x = 0.0;
-  if(theLambdaTable) x = GetLambdaFromTable(e);
-  else               x = ComputeCurrentLambda(e);
+inline G4double G4VEmProcess::MeanFreePath(const G4Track& track)
+{
+  DefineMaterial(track.GetMaterialCutsCouple());
+  preStepLambda = GetCurrentLambda(track.GetKineticEnergy());
+  G4double x = DBL_MAX;
+  if(DBL_MIN < preStepLambda) x = 1.0/preStepLambda;
   return x;
 }
@@ -684,13 +453,233 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline G4double G4VEmProcess::ComputeCurrentLambda(G4double e)
-{
-  SelectModel(e);
-  G4double x = 0.0;
-  if(currentModel) {
-    x = currentModel->CrossSectionPerVolume(currentMaterial,particle,
-					    e,(*theCuts)[currentMaterialIndex]);
-  }
-  return x;
+inline G4VEmModel* G4VEmProcess::SelectModel(G4double& kinEnergy)
+{
+  return modelManager->SelectModel(kinEnergy, currentMaterialIndex);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4VEmModel* G4VEmProcess::SelectModelForMaterial(
+                                   G4double kinEnergy, size_t& idxRegion) const
+{
+  return modelManager->SelectModel(kinEnergy, idxRegion);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline const G4ParticleDefinition* G4VEmProcess::Particle() const
+{
+  return particle;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline const G4ParticleDefinition* G4VEmProcess::SecondaryParticle() const
+{
+  return secondaryParticle;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::GetGammaEnergyCut()
+{
+  return (*theCutsGamma)[currentMaterialIndex];
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::GetElectronEnergyCut()
+{
+  return (*theCutsElectron)[currentMaterialIndex];
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetLambdaFactor(G4double val)
+{
+  if(val > 0.0 && val <= 1.0) lambdaFactor = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4VEmModel* G4VEmProcess::GetModelByIndex(G4int idx, G4bool ver)
+{
+  return modelManager->GetModel(idx, ver);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4ParticleChangeForGamma* G4VEmProcess::GetParticleChange()
+{
+  return &fParticleChange;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetParticle(const G4ParticleDefinition* p)
+{
+  particle = p;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetSecondaryParticle(const G4ParticleDefinition* p)
+{
+  secondaryParticle = p;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::AddEmModel(G4int order, G4VEmModel* p, 
+				     const G4Region* region)
+{
+  G4VEmFluctuationModel* fm = 0;
+  modelManager->AddEmModel(order, p, fm, region);
+  if(p) p->SetParticleChange(pParticleChange);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetModel(G4VEmModel* model)
+{
+  selectedModel = model;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4VEmModel* G4VEmProcess::Model()
+{
+  return selectedModel;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::UpdateEmModel(const G4String& nam, 
+					G4double emin, G4double emax)
+{
+  modelManager->UpdateEmModel(nam, emin, emax);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::ComputeCrossSectionPerAtom(
+		 G4double kineticEnergy, G4double Z, G4double A, G4double cut)
+{
+  G4VEmModel* model = SelectModel(kineticEnergy);
+  return model->ComputeCrossSectionPerAtom(particle,kineticEnergy,Z,A,cut);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetLambdaBinning(G4int nbins)
+{
+  nLambdaBins = nbins;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4int G4VEmProcess::LambdaBinning() const
+{
+  return nLambdaBins;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetMinKinEnergy(G4double e)
+{
+  minKinEnergy = e;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::MinKinEnergy() const
+{
+  return minKinEnergy;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetMaxKinEnergy(G4double e)
+{
+  maxKinEnergy = e;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::MaxKinEnergy() const
+{
+  return maxKinEnergy;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetPolarAngleLimit(G4double val)
+{
+  if(val < 0.0)     polarAngleLimit = 0.0;
+  else if(val > pi) polarAngleLimit = pi;
+  else              polarAngleLimit = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4VEmProcess::PolarAngleLimit() const
+{
+  return polarAngleLimit;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::ActivateDeexcitation(G4bool, const G4Region*)
+{}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline const G4PhysicsTable* G4VEmProcess::LambdaTable() const
+{
+  return theLambdaTable;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetIntegral(G4bool val)
+{
+  if(particle && particle != theGamma) integral = val;
+  if(integral) buildLambdaTable = true;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4bool G4VEmProcess::IsIntegral() const
+{
+  return integral;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetBuildTableFlag(G4bool val)
+{
+  buildLambdaTable = val;
+  if(!val) integral = false;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetStartFromNullFlag(G4bool val)
+{
+  startFromNull = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4VEmProcess::SetApplyCuts(G4bool val)
+{
+  applyCuts = val;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline size_t G4VEmProcess::CurrentMaterialCutsCoupleIndex() const 
+{
+  return currentMaterialIndex;
 }
 
